/* ClientSocket.cpp
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include "ClientSocket.h"
#include <iostream>
#include <unistd.h>

#ifdef WIN32
  #include <winsock2.h>
#else
  #include <sys/socket.h>
  #include <arpa/inet.h>
  #include <netdb.h>
#endif

using std::cerr;
using std::endl;

// Static variables
std::string ClientSocket::Author = "Hellfire";
std::string ClientSocket::Name = "ClientSocket";
std::string ClientSocket::Abbreviation = "CLSC";
long ClientSocket::Count = 0;


// Constructor
ClientSocket::ClientSocket() {
  Count++;
}

// Destructor
ClientSocket::~ClientSocket() {
  Count--;
}

// Connect to a server
bool ClientSocket::Connect(std::string hostname, unsigned short port) {
  cerr << "Connecting to " << hostname << ":" << port << endl;
  
  int err;
  
  // Open a socket
  Sock = socket(PF_INET, SOCK_STREAM, 0);

  if(!Sock) {
    cerr << "Error while opening a socket!" <<endl;
    return false;
  }
  
  // Step 2: Connect the socket to the hostname and address
  struct sockaddr_in addr;
  memset(&addr, 0, sizeof(addr));
  addr.sin_family = AF_INET;
//  addr.sin_addr.s_addr = inet_addr("127.0.0.1");
// TODO: Replace gethostbyname with getaddrinfo. The former is deprecated and 
// cannot parse IP addresses!
  addr.sin_addr.s_addr = 
    *((unsigned long*)gethostbyname(hostname.c_str())->h_addr_list[0]);
  addr.sin_port = htons(port);
  
  err = connect(Sock, (struct sockaddr*)&addr, sizeof(addr));
  if(err) {
    cerr << "Error while connecting the socket to an address!" << endl;
    return false;
  }
  
  return true;
}
