#ifndef __CLIENTSOCKET_H__
#define __CLIENTSOCKET_H__

/* ClientSocket.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include <string>
#include "Socket.h"

/* Class ClientSocket:
 * 
 * Connects to a server socket. This class can send and receive messages from
 * the server and convert them to Packet objects.
 */

class ClientSocket : public Socket {
public:
  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;
  
  // Constructor and Destructor
  ClientSocket();
  virtual ~ClientSocket();
  
  // Connect to a server
  bool Connect(std::string hostname, unsigned short port);
};

#endif // __CLIENTSOCKET_H__
