#ifndef __PACKET_H__
#define __PACKET_H__

/* Packet.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */


/* Class Packet:
 * 
 * Provides a generic interface to small classes that can be serialized for
 * transmission over a network.
 */

class Packet {
public:
  // Return the packet's type identifier
  virtual unsigned short GetType() = 0;
  
  // Calculate the number of bytes this packet will use
  virtual unsigned long Length() = 0;
  
  // Fill a buffer with the data in the packet
  virtual unsigned long FillBuffer(char *buffer, unsigned long buflen) = 0;
  
  // Reconstruct ourselfs from a serialized version
  virtual bool ParseBuffer(char *Buffer, unsigned long buflen) = 0;
};

#endif // __PACKET_H__
