/* PacketFactory.cpp
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include "PacketFactory.h"
#include "TestPacket.h"
#include "TestReplyPacket.h"

// Static variables
PacketFactory *PacketFactory::Instance = NULL;

std::string PacketFactory::Author = "Hellfire";
std::string PacketFactory::Name = "PacketFactory";
std::string PacketFactory::Abbreviation = "PFCT";
long PacketFactory::Count = 0;

// Constructor
PacketFactory::PacketFactory() {
}

// Get the only object of the PacketFactory class
PacketFactory *PacketFactory::GetInstance() {
  if(Instance == NULL) {
    Instance = new PacketFactory();
  }
  
  return Instance;
}

// Reconstruct a packet from a stream buffer
Packet *PacketFactory::Reconstruct(char *buffer, unsigned int bufLen) {
  unsigned short type;
  unsigned short length;
  
  type = buffer[0] << 8 | buffer[1];
  length = buffer[2] << 8 | buffer[3];
  
  // Can't reconstruct a packet if the buffer was too small
  if(bufLen < length) {
    return NULL;
  }
  
  Packet *packet = NULL;
  
  switch(type) {
    case 1:
      packet = new TestPacket();
      break;
    case 2:
      packet = new TestReplyPacket();
      break;
    
    default:
      return NULL;
  }
  
  packet->ParseBuffer(buffer, bufLen);
  
  return packet;
}
