/* TestPacket.cpp
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include "TestPacket.h"

// Static variables
std::string TestPacket::Author = "Hellfire";
std::string TestPacket::Name = "TestPacket";
std::string TestPacket::Abbreviation = "TSTP";
long TestPacket::Count = 0;

// Constructor
TestPacket::TestPacket() {
  Count++;
}

// Destructor
TestPacket::~TestPacket() {
  Count--;
}

// Return the packet's type identifier
unsigned short TestPacket::GetType() {
  return 1;
}

unsigned long TestPacket::Length() {
  return 4;
}

unsigned long TestPacket::FillBuffer(char *buffer, unsigned long bufLen) {
  // All packets start with a 16-bit type identifier and a 16-bit length. This
  // limits the maximum length of a packet to 65532 bytes, which should be
  // enough for most packets.
  
  unsigned long length = Length();
  unsigned long offset = 0;
  
  // Don't allow buffers that are too small
  if(bufLen < length) {
    return 0;
  }
  
  // Add type and length to the buffer
  buffer[0] = 0;
  buffer[1] = 1;
  buffer[2] = 0;
  buffer[3] = 4;
  
  return 4;
}

// Reconstruct ourselfs from a serialized version
bool TestPacket::ParseBuffer(char *Buffer, unsigned long buflen) {
  return false;
}
