/* TestPacket.cpp
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include "TestReplyPacket.h"

// Static variables
std::string TestReplyPacket::Author = "Hellfire";
std::string TestReplyPacket::Name = "TestReplyPacket";
std::string TestReplyPacket::Abbreviation = "TSRP";
long TestReplyPacket::Count = 0;

// Constructor
TestReplyPacket::TestReplyPacket() {
  Count++;
}

// Destructor
TestReplyPacket::~TestReplyPacket() {
  Count--;
}

// Return the packet's type identifier
unsigned short TestReplyPacket::GetType() {
  return 2;
}

unsigned long TestReplyPacket::Length() {
  return 4;
}

unsigned long TestReplyPacket::FillBuffer(char *buffer, unsigned long bufLen) {
  // All packets start with a 16-bit type identifier and a 16-bit length. This
  // limits the maximum length of a packet to 65532 bytes, which should be
  // enough for most packets.
  
  unsigned long length = Length();
  unsigned long offset = 0;
  
  // Don't allow buffers that are too small
  if(bufLen < length) {
    return 0;
  }
  
  // Add type and length to the buffer
  buffer[0] = 0;
  buffer[1] = 2;
  buffer[2] = 0;
  buffer[3] = 4;
  
  return 4;
}

// Reconstruct ourselfs from a serialized version
bool TestReplyPacket::ParseBuffer(char *Buffer, unsigned long buflen) {
  return false;
}
