#ifndef __TESTREPLYPACKET_H__
#define __TESTREPLYPACKET_H__

/* TestPacket.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include "Packet.h"
#include <string>

/* Class TestPacket:
 * 
 * A simple packet, for testing purposes.
 */

class TestReplyPacket : public Packet {
public:
  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;
  
  // Constructor and Destructor
  TestReplyPacket();
  virtual ~TestReplyPacket();
  
  // Abstract methods from Packet
  virtual unsigned short GetType();
  virtual unsigned long Length();
  virtual unsigned long FillBuffer(char *Buffer, unsigned long Buflen);
  virtual bool ParseBuffer(char *Buffer, unsigned long buflen);
};

#endif // __TESTREPLYPACKET_H__
