#ifndef __SERVERSOCKET_H__
#define __SERVERSOCKET_H__

/* ServerSocket.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include <string>
#include "Socket.h"

/* Class ServerSocket:
 * 
 * Creates a server socket. This class can send and receive messages from one
 * client and convert them to Packet objects.
 */

class ServerSocket : public Socket {
protected:
//  int Sock;
  
public:
  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;
  
  // Constructor and Destructor
  ServerSocket();
  ~ServerSocket();
  
  // Open a port
  bool OpenPort(unsigned short port);
  
  // Accept a connection
  ServerSocket* AcceptConnection();
};

#endif // __SERVERSOCKET_H__
