#include "ServerSocket.h"
#include "TestReplyPacket.h"
#include "Map.h"
#include <iostream>

using namespace std;

int main(int argc, char *argv[]) {
  
  // Create a random map
  Map *map = new Map();
  map->Random(16, 16);
  
  // Create connection
  ServerSocket *ss = new ServerSocket();
  if(!ss->OpenPort(4000)) {
    return -1;
  }
  
  // Accept an incoming connection
  ServerSocket *cns = ss->AcceptConnection();
  
  if(cns == NULL) {
    return -1;
  }
  
  // Receive a packet
  Packet *packet = cns->ReceivePacket();
  
  if(packet != NULL) {
    cout << "Packet received!" << endl;
    
    if(packet->GetType() == 1) {
      cout << "The packet has the right type! :D" << endl;
    }
  } else {
    delete packet;
    delete cns;
    delete ss;
    delete map;
    return -1;
  }
  
  // Send a reply
  delete packet;
  packet = new TestReplyPacket();
  
  cns->SendPacket(packet);
  
  cout << "Sent reply." << endl;
  
  // Clean up
  delete packet;
  delete cns;
  delete ss;
  delete map;
  
  return 0;
}
